"""
$Id: test_weblogentry.py 25188 2006-06-20 16:45:29Z reinout $
"""

import os, sys
if __name__ == "__main__":
    execfile(os.path.join(sys.path[0], "framework.py"))

from Testing import ZopeTestCase
from Products.Quills.tests import QuillsTestCase

from Products.Quills import config


class TestWeblogEntry(QuillsTestCase.QuillsTestCase):

    def afterSetUp(self):
        self.login()
        self.setRoles(["Manager"])
        self.folder.invokeFactory("Weblog", id="weblog", title="Test Weblog")
        self.weblog = getattr(self.folder, "weblog")
        self.weblog.invokeFactory("WeblogEntry", "entry",
                                  title="Test Entry")

    def testEntry(self):

        from Products.CMFCore import CMFCorePermissions
        from Products.Quills.WeblogEntry import WeblogEntrySchema

        entry = getattr(self.weblog, "entry")
        self.assertEquals(entry.id,
                          "entry")
        self.assertEquals(entry.title,
                          "Test Entry")
        self.assertEquals(entry.schema,
                          WeblogEntrySchema)
        self.assertEquals(entry.archetype_name,
                          "Weblog Entry")
        self.assertEquals(entry.meta_type,
                          'WeblogEntry')
        self.assertEquals(entry.content_icon,
                          'weblogentry_icon.gif')
        self.assertEquals(entry.global_allow,
                          False)
        self.assertEquals(entry.default_view,
                          'weblogentry_view')
        self.assertEquals(entry.immediate_view,
                          'weblogentry_view')
        self.assertEquals(entry.schema['allowDiscussion'].default,
                          0)
        self.assertEquals(entry.schema['id'].widget.visible,
                          {'view': 'invisible'})
        self.failUnless(entry.start() == entry.end(),
                        "start and end should be the same")


    def testEntryCategories(self):
        entry = getattr(self.weblog, "entry")

        cats = [cat for cat in entry.Subject()]
        self.failUnlessEqual(cats, [])


    # Trackback tests now live in plonetrackback.tests
    #def testEntryTrackbacks(self):



def test_suite():
    from unittest import TestSuite, makeSuite
    suite = TestSuite()
    suite.addTest(makeSuite(TestWeblogEntry))
    return suite

if __name__ == '__main__':
    framework()
